fitur_forum/urls.py
from django.conf.urls import url
from .views import index, add_message, dashboard
from .custom_auth import auth_login, auth_logout

urlpatterns = [
	url(r'^$', index, name='index'),
	url(r'^add_message/(?P<id>.*)/$', add_message, name='add_message'),
	url(r'^dashboard/$', dashboard, name='dashboard'),

	# custom auth
	url(r'^custom_auth/login/$', auth_login, name='auth_login'),
	url(r'^custom_auth/logout/$', auth_logout, name='auth_logout'),
]
       
    

home/urls.py
from django.conf.urls import url
from .views import index, profile
from .views import add_session, del_session, add_message, dashboard

urlpatterns = [
    url(r'^$', index, name='index'),
	url(r'^profile/$', profile, name='profile'),
    url(r'add-session', add_session, name='add-session'),
    url(r'del-session', del_session, name='del-session'),
	url(r'^add_message/(?P<id>.*)/$', add_message, name='add_message'),
	url(r'^dashboard/', dashboard, name='dashboard'),
    ]

linkedin2/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.views.generic.base import RedirectView
import home.urls as home
import tanggapan_lowongan.urls as tanggapan_lowongan
import fitur_forum.urls as forum

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^home/', include(home, namespace='home')),
    url(r'^forum/', include(forum,namespace='forum')),
    url(r'^tanggapan-lowongan/', include(tanggapan_lowongan, namespace='tanggapan_lowongan')),
    url(r'^$', RedirectView.as_view(url="/home/", permanent="true"), name="index"),
]

fitur_forum/models.py
from django.db import models

# Create your models here.
class Pengguna(models.Model):
    kode_identitas = models.CharField('Kode Identitas', max_length=20, primary_key=True, )
    nama = models.CharField('Nama', max_length=200)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

class Message(models.Model):
	pengguna = models.ForeignKey(Pengguna)
	title = models.CharField(max_length=140)
	message = models.TextField()
	kode_message = models.CharField("Kode Message", max_length=50)
	created_date = models.DateTimeField(auto_now_add=True)

#class Comment2(models.Model):
#	pengguna = models.ForeignKey(Pengguna)
#	message = models.ForeignKey(Message)
#	comment = models.TextField()
#	created_date = models.DateTimeField(auto_now_add=True)

home/models.py
from django.db import models

# Create your models here.
class Pengguna(models.Model):
	kode_identitas = models.CharField('Kode Identitas', max_length=20, primary_key=True)
	nama = models.CharField('Nama', max_length=200)
	url =  models.CharField('Url', max_length=500)
	
class Message(models.Model):
	pengguna = models.ForeignKey(Pengguna)
	title = models.CharField(max_length=140)
	message = models.TextField()
	kode_message = models.CharField("Kode Message", max_length=50)
	created_date = models.DateTimeField(auto_now_add=True)

class Comment(models.Model):
	pengguna = models.ForeignKey(Pengguna)
	message = models.ForeignKey(Message)
	comment = models.TextField()
	created_date = models.DateTimeField(auto_now_add=True)

fitur_forum/forms.py
from django import forms

class Message_Form(forms.Form):
    error_messages = {
        'required': 'Tolong isi input ini',
        'invalid': 'Isi input dengan email',
    }
    attrs = {
        'class': 'form-control'
    }

    title_attrs = {
        'class': 'form-control',
        'placeholder':'This post is about...'
    }
 
    message_attrs = {
        'class': 'form-control',
        'placeholder':'Your post is...'
    }

    title = forms.CharField(label='Judul Forum', required=True, max_length=30, widget=forms.TextInput(attrs=title_attrs))
    message = forms.CharField(widget=forms.Textarea(attrs=message_attrs), required=True)

home/forms.py
from django import forms

class Message_Form(forms.Form):
    error_messages = {
        'required': 'Tolong isi input ini',
        'invalid': 'Isi input dengan email',
    }
    attrs = {
        'class': 'form-control'
    }

    title_attrs = {
        'class': 'form-control',
        'placeholder':'This post is about...'
    }

    message_attrs = {
        'class': 'form-control',
        'placeholder':'Your post is...'
    }

    title = forms.CharField(label='Judul Forum', required=True, max_length=30, widget=forms.TextInput(attrs=title_attrs))
    message = forms.CharField(widget=forms.Textarea(attrs=message_attrs), required=True)

fitur_forum/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from .forms import Message_Form
from .models import Message
from .utils import *

# Create your views here.
response = {}
def index(request):
    # print ("#==> masuk index")
    if 'user_login' in request.session:
        return HttpResponseRedirect(reverse('forum:dashboard'))
    else:
        response['author'] = get_data_user(request, 'user_login')
        html = 'fitur_forum/login.html'
        return render(request, html, response)

def dashboard(request):
    
    if not 'user_login' in request.session.keys():
        return HttpResponseRedirect(reverse('forum:index'))
    else:
        kode_identitas = get_data_user(request, 'kode_identitas')
        try:
            pengguna = Pengguna.objects.get(kode_identitas = kode_identitas)
        except Exception as e:
            pengguna = create_new_user(request)

        message = Message.objects.filter(pengguna=pengguna)
        
        response['message'] = message
        response['message_form'] = Message_Form
        response["message_list"] = message
        html = 'fitur_forum/fitur_forum.html'
        
        message_list = message
        paginator = Paginator(message_list, 5)
        page = request.GET.get('page', 1)
        try:
            users = paginator.page(page)
        except PageNotAnInteger:
            users = paginator.page(1)
        except EmptyPage:
            users = paginator.page(paginator.num_pages)
       
        response["message_list"] = users
        html = 'fitur_forum/fitur_forum.html'
        return render(request, html, response)

def add_message(request, id):
    response['id'] = id
    form = Message_Form(request.POST or None)

    if (request.method == 'POST' and form.is_valid()):
        kode_identitas = get_data_user(request, 'kode_identitas')
        try:
            pengguna = Pengguna.objects.get(kode_identitas = kode_identitas)
        except Exception as e:
            pengguna = create_new_user(request)  
     
        response['title'] = request.POST['title'] 
        response['message'] = request.POST['message']
        message = Message(pengguna=pengguna,title=response['title'], message=response['message'], kode_message = id)
        message.save()
        response['id'] = id
        html ='fitur_forum/fitur_forum.html'    
        return HttpResponseRedirect('/forum/')

def paginate_page(page, data_list):
    paginator = Paginator(data_list, 5)

    try:
        data = paginator.page(page)
    except PageNotAnInteger:
        data = paginator.page(1)
    except EmptyPage:
        data = paginator.page(paginator.num_pages)

    # Get the index of the current page
    index = data.number - 1
    # This value is maximum index of your pages, so the last page - 1
    max_index = len(paginator.page_range)
    # You want a range of 10, so lets calculate where to slice the list
    start_index = index if index >= 5 else 0
    end_index = 5 if index < max_index - 5 else max_index
    # Get our new page range. In the latest versions of Django page_range returns 
    # an iterator. Thus pass it to list, to make our slice possible again.
    page_range = list(paginator.page_range)[start_index:end_index]
    paginate_data = {'data':data, 'page_range':page_range}
    return paginate_data

home/views.py
from django.shortcuts import render, redirect
from django.views.decorators.csrf import csrf_exempt
from django.http import HttpResponse, HttpResponseRedirect, JsonResponse
from django.urls import reverse
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from .forms import Message_Form
from .models import Pengguna, Message
import json

response = {}

def index(request):
	if 'logged' in request.session :
		return HttpResponseRedirect('/home/profile/')
	else :
		return render(request, 'home/login.html', response)

def profile(request):
	if 'logged' not in request.session :
		return HttpResponseRedirect('/home/')
	## end of sol
	html = 'home/profile.html'
	return render(request, html, response)
	
def dashboard(request):
	if 'logged' not in request.session:
		return HttpResponseRedirect('/home/')
	## end of sol
	else:
		kode_identitas = get_data_user(request, 'kode_identitas')
		try:
			pengguna = Pengguna.objects.get(kode_identitas = kode_identitas)
		except Exception as e:
			pengguna = create_new_user(request)

		message = Message.objects.filter(pengguna=pengguna)
        
		response['message'] = message
		response['message_form'] = Message_Form
		response["message_list"] = message
		html = 'fitur_forum/fitur_forum.html'
        
		message_list = message
		paginator = Paginator(message_list, 5)
		page = request.GET.get('page', 1)
		try:
			users = paginator.page(page)
		except PageNotAnInteger:
			users = paginator.page(1)
		except EmptyPage:
			users = paginator.page(paginator.num_pages)
       
		response["message_list"] = users
		html = 'home/fitur_forum.html'
		return render(request, html, response)

def add_message(request, id):
    response['id'] = id
    form = Message_Form(request.POST or None)

    if (request.method == 'POST' and form.is_valid()):
        kode_identitas = get_data_user(request, 'kode_identitas')
        try:
            pengguna = Pengguna.objects.get(kode_identitas = kode_identitas)
        except Exception as e:
            pengguna = create_new_user(request)  
     
        response['title'] = request.POST['title'] 
        response['message'] = request.POST['message']
        message = Message(pengguna=pengguna,title=response['title'], message=response['message'], kode_message = id)
        message.save()
        response['id'] = id
        html ='home/fitur_forum.html'    
        return HttpResponseRedirect('/home/')

def paginate_page(page, data_list):
    paginator = Paginator(data_list, 5)

    try:
        data = paginator.page(page)
    except PageNotAnInteger:
        data = paginator.page(1)
    except EmptyPage:
        data = paginator.page(paginator.num_pages)
    # Get the index of the current page
    index = data.number - 1
    # This value is maximum index of your pages, so the last page - 1
    max_index = len(paginator.page_range)
    # You want a range of 10, so lets calculate where to slice the list
    start_index = index if index >= 5 else 0
    end_index = 5 if index < max_index - 5 else max_index
    # Get our new page range. In the latest versions of Django page_range returns 
    # an iterator. Thus pass it to list, to make our slice possible again.
    page_range = list(paginator.page_range)[start_index:end_index]
    paginate_data = {'data':data, 'page_range':page_range}
    return paginate_data
		
@csrf_exempt
def add_session(request):
	if request.method == 'POST':
		request.session['logged']= True
		try:
			pengguna = Pengguna.objects.get(kode_identitas = request.POST['id'])
			print("username exists")
		except Exception as e:
			pengguna = Pengguna()
			pengguna.kode_identitas = request.POST['id']
			pengguna.nama = request.POST['nama']
			pengguna.url =  request.POST['url']
			pengguna.save()
			print("user created")
		return render(request, 'home/profile.html', response)

@csrf_exempt
def del_session(request):
	if request.method == 'POST':
		request.session.flush()
		print("LOGGED OUT")	 
		return HttpResponseRedirect('/home/')

home/templates/home/fitur_forum.html
{% extends "home/layout/base.html" %}
{% load staticfiles %}
{% load static %}



{% block content %}
<div class="jumbotron jumbotron-fluid text-center" style="margin-bottom: 0px; margin-top: 0px; background-color: #F1F7ED">
  <div class="container">
    <h1 class="display-3" style="font-family: Impact;">Forum Diskusi Lowongan</h1>
    <h4 class="lead" style="fontfamily: Lucida">find jobs here</h4>
  </div>
</div>

<section name="form">
    <h2>Send Message</h2>
    <form id="form" method="POST" action="{% url 'home:add_message' id %}">
        {% csrf_token %}
        {{ message_form }}
        <br>
        <button type="submit" class="btn btn-default">Submit</button>
    </form>
</section>
<div class="list-group">
{% if message_list %}
         
        {% for i in message_list %}
        <a class="list-group-item clearfix"> 
            {{i.title}} - {{i.message}} - {{i.created_date}} 
        </a>        
        {% endfor %}
  
{% else %}
    <button type="submit" class="btn btn-primary btn-lg btn-block no-friend">You have no discussion.</button>
{% endif %}
</div>

{% if message_list.has_other_pages %}
    <ul class="pagination">
        {% if message_list.has_previous %}
            <li><a href="?page={{ message_list.previous_page_number }}">&laquo;</a></li>
        {% else %}
            <li class="disabled"><span>&laquo;</span></li>
        {% endif %}

        {% for i in message_list.paginator.page_range %}
            {% if message_list.number == i %}
                <li class="active"><span>{{ i }} <span class="sr-only">(current)</span></span></li>
            {% else %}
                <li><a href="?page={{ i }}">{{ i }}</a></li>
            {% endif %}
        {% endfor %}
        {% if message_list.has_next %}
              <li><a href="?page={{ message_list.next_page_number }}">&raquo;</a></li>
        {% else %}
              <li class="disabled"><span>&raquo;</span></li>
        {% endif %}
    </ul>
{% endif %}
{% endblock %}

home/templates/home/login.html
{% extends "home/layout/base.html" %}
{% block content %}
<script type="text/javascript" src="//platform.linkedin.com/in.js">
    api_key:   81aavc9cxoi79i
    onLoad:    onLinkedInLoad
    authorize: true
</script>

<div class="container">
  <div class="jumbotron">
    <h1>Find Jobs Fast</h1> 
        <p>Cari kerja, cari magang cepat cuma disini. Login dengan account SSO UI dan LinkedIN mu.</p> 
    <script type="in/Login"></script>
  </div>
</div>

{% endblock %}

home/templates/home/profile.html
{% extends "home/layout/base.html" %}
{% block content %}
{% load staticfiles %}
{% load static %}
<link rel="stylesheet" href="css/profile.css">
<link rel="stylesheet" href="{% static 'css/profile.css' %}">
<script type="text/javascript" src="//platform.linkedin.com/in.js"></script>

<div class="discover clearfix" style="margin-top: -80px;">
    <div class="wrap">
        <div class="discover-content clearfix">
            <h2>{{ name }}</h2>
            <h3>{{ companyType }} Company</h3>
            <p>{{ description }}</p>
            <span id="Name"></span>
            <div class="discover-button clearfix">
                <a href="/forum/" class="button button-download">
                    <span class="button-download-title">Lihat</span>
                    <span class="button-download-subtitle">Forum</span>
                </a>
                <a href="/tambah_lowongan/" class="button button-download">
                    <span class="button-download-title">Tambah</span>
                    <span class="button-download-subtitle">Lowongan</span>
                </a>
                <a href="./" onClick="logout()" class="button button-download">
                	<span class="button-download-title">Keluar</span>
				    <span class="button-download-subtitle">Logout</span>
				</a>
            </div>
        </div>
        <div class="discover-img">
            <div class="discover-img-inside"><img src="{{ image }}" height="400" width="400" alt="" style="margin-top: 100px;"></div>
        </div>
    </div>
</div>


<div class="wrap">
    <div class="promo-wrapper clearfix">
    	<div class="promo-column">
            <img src="upload/pin.png" height="32" width="24" alt="">
            <h5>Location</h5>
            <p>{{ location }}</p>
        </div>
        <div class="promo-column">
            <img src="upload/pin.png" height="32" width="24" alt="">
            <h5>Specialties</h5>
            {% for item in specialties %}
            <p>{{ item }}</p>
            {% endfor %}
        </div>
        <div class="promo-column">
            <img src="upload/easy.png" height="32" width="34" alt="">
            <h5>Founded Year</h5>
            <p>{{ foundedYear }}</p>
        </div>
        <div class="promo-column">
            <img src="upload/saturn.png" height="32" width="32" alt="">
            <h5>Website URL</h5>
            <p>{{ websiteUrl }}</p>
        </div>
    </div>
</div>




{% endblock %}